> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gomaestro.org/llms.txt
> Use this file to discover all available pages before exploring further.

> Get Bitcoin Runes holders with mempool awareness including pending transfers and real-time balance updates.

# Holders by Rune (Mempool-aware)



## OpenAPI

````yaml bitcoin/mempool-monitoring-api/openapi.json get /mempool/assets/runes/{rune}/holders
openapi: 3.0.3
info:
  title: Bitcoin - Mempool Monitoring API
  description: >-
    Maestro's Bitcoin Mempool Monitoring API offers core indexer endpoints with
    mempool awareness, providing real-time visibility into unconfirmed
    transactions, enabling developers to build responsive, fee-optimized, and
    mempool-aware applications without managing their own node infrastructure.


    #### Key Features:

    - **Real-Time Transaction Monitoring:** Track unconfirmed transactions
    instantly as they enter the mempool, providing immediate insights for
    enhanced user experience.

    - **Optimal Fee Estimation:** Analyze current mempool conditions to help
    users set appropriate transaction fees, ensuring timely confirmations and
    cost efficiency.

    - **Network Health Analysis:** Monitor mempool size and state to detect
    network congestion and anomalies, aiding in informed decision-making
    regarding transaction timing.

    - **Custom Transaction Selection for Miners:** Utilize mempool data to
    prioritize transactions with higher fees, maximizing profits during block
    construction.


    #### Key Benefits for Developers:

    Developers can enhance their applications and improve user experience
    through real-time blockchain insights and optimized transaction processing.
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.txt
  version: v0.1.0
servers:
  - url: https://xbt-mainnet.gomaestro-api.org/v0
    description: Bitcoin Mainnet
  - url: https://xbt-testnet.gomaestro-api.org/v0
    description: Bitcoin Testnet
security:
  - api-key: []
paths:
  /mempool/assets/runes/{rune}/holders:
    get:
      tags:
        - Runes
      summary: Holders by Rune (Mempool-aware)
      description: >-
        Lists all addresses currently holding a given Rune, with corresponding
        balances. Helps visualize token distribution and adoption.


        In addition to confirmed transactions, mempool endpoints return data
        which reflects pending transactions in some number of "estimated" blocks
        - predicted blocks containing transactions which have been propagated
        around the network but not yet included in a mined block, with
        transactions with a higher sat/vB value being prioritised. The response
        details how many of these estimated blocks were considered when fetching
        the data.
      operationId: mempool_holders_by_rune
      parameters:
        - name: rune
          in: path
          description: >-
            Rune, specified either by the Rune ID (etching block number and
            transaction index) or name (spaced or un-spaced)
          required: true
          schema:
            type: string
          example: '2519999:31'
        - name: count
          in: query
          description: The max number of results per page
          required: false
          schema:
            allOf:
              - type: integer
                default: 100
                minimum: 0
            nullable: true
        - name: cursor
          in: query
          description: >-
            Pagination cursor string, use the cursor included in a page of
            results to fetch the next page
          required: false
          schema:
            type: string
            nullable: true
      responses:
        '200':
          description: Requested data
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MempoolPaginatedRuneHolder'
              example:
                data:
                  - address: bc1q764zfcx3uw0dcvcdh7nnwm5fvsml0c2tgn942v
                    balance: '9000000.000000000000000000'
                    script_pubkey: 0014f6aa24e0d1e39edc330dbfa7376e896437f7e14b
                  - address: >-
                      bc1pqfhj6tlxgpvc72mvn9hh0z666k45fpxgsej92d9q08sfe572mhlqca68ld
                    balance: '420000.000000000000000000'
                    script_pubkey: >-
                      5120026f2d2fe640598f2b6c996f778b5ad5ab4484c886645534a079e09cd3caddfe
                indexer_info:
                  chain_tip:
                    block_hash: >-
                      00000000000000000002da06787fe86324e1cc1421861d899b7bd1e340aa1930
                    block_height: 867154
                  estimated_blocks:
                    - block_height: 867155
                      sats_per_vb:
                        max: 16
                        median: 14
                        min: 12
                  mempool_timestamp: '2025-01-06 16:43:32'
                next_cursor: null
        '400':
          description: Malformed query parameters
        '404':
          description: Requested entity not found on-chain
        '500':
          description: Internal server error
components:
  schemas:
    MempoolPaginatedRuneHolder:
      type: object
      required:
        - data
        - indexer_info
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/RuneHolder'
        indexer_info:
          $ref: '#/components/schemas/MempoolLastUpdated'
        next_cursor:
          type: string
          nullable: true
    RuneHolder:
      type: object
      required:
        - script_pubkey
        - balance
      properties:
        address:
          type: string
          nullable: true
        balance:
          type: string
        script_pubkey:
          type: string
    MempoolLastUpdated:
      type: object
      required:
        - chain_tip
        - estimated_blocks
      properties:
        chain_tip:
          $ref: '#/components/schemas/ChainTip'
        estimated_blocks:
          type: array
          items:
            $ref: '#/components/schemas/EstimatedBlock'
          description: >-
            Information about any estimated blocks from the mempool that were
            indexed in addition to the mainchain
        mempool_timestamp:
          type: string
          description: >-
            Timestamp of the indexed mempool snapshot, if any estimated blocks
            from the mempool have been indexed
          nullable: true
    ChainTip:
      type: object
      required:
        - block_hash
        - block_height
      properties:
        block_hash:
          type: string
          description: The hash of the block
          example: 0000000000000000000a7f3b7b6b6e1d9a18db65a3b4a3f4f3bcb2e1f1b2d3e7
        block_height:
          type: integer
          format: int64
          description: The height of the block in the blockchain
          example: 707000
          minimum: 0
    EstimatedBlock:
      type: object
      required:
        - block_height
        - sats_per_vb
      properties:
        block_height:
          type: integer
          format: int64
          description: Height of the estimated block
          example: '707001'
          minimum: 0
        sats_per_vb:
          $ref: '#/components/schemas/BlockSatsPerVb'
    BlockSatsPerVb:
      type: object
      description: >-
        For transactions within a block, these are the lowest, median and
        highest

        satoshis per virtual-byte values.
      required:
        - min
        - median
        - max
      properties:
        max:
          type: integer
          format: int64
          description: Highest sat/vB value of the transactions within the block
          example: 255
          minimum: 0
        median:
          type: integer
          format: int64
          description: Median sat/vB value of the transactions within the block
          example: 15
          minimum: 0
        min:
          type: integer
          format: int64
          description: Lowest sat/vB value of the transactions within the block
          example: 11
          minimum: 0
  securitySchemes:
    api-key:
      type: apiKey
      in: header
      name: api-key
      description: Project API Key

````